/* **************************************************
   get_str procedure ver 1.0
   control keys:
    ALPHA  - switches between alpha and numeric mode
    SHIFT  - when in alpha mode switches between
             upper and lower case
    LEFT ARROW, DEL - works as backspace
    EXE,F6 - enter key, F6 is because PC tests

    I'm waiting for any sugestions of improvements,
    contact:Jarek Wosik (Roeoender)
            drzodrzo@kki.net.pl
    use:
      your program must contain lines:
      #include <stdio.h>
      #include <conio.h>
      #include "get_str.cpp"
      both get_str.cpp and keyb.cpp must be in
      current directory.
   ************************************************** */
// F6 (64) is uncommented works as enter key for PC
//#include <conio.h>
//#include <stdio.h>
#include "keyb.cpp"  //list of keys
//casio
#define ALPHA_MODE 0 //for InitMode
#define UCASE_MODE 1 //upper case
#define NUM_MODE 2   //---||---
#define ALPHA_DIST 32//distance betwwen low and upper case in ASCII table

void get_str (char *str ,int size, char mode) {
  int index=0;
  char key;
  char UpCase=0;//may be 0 (up) or ALPHA_DIST (low)
  char ndone=1;

//!!! here may be a buffer clear flush buff or something
  while ((index<size)&&(ndone)) {
    key = getch ();
    if (key == 0) {
      key = getch ();
      switch (key) {
//        case 60://comment this for casio
        case ALPHA_EK:  //change mode between alpa and num
               if (mode==ALPHA_MODE) mode=NUM_MODE;
	       else mode=ALPHA_MODE;
        break;
//        case 61://comment this for casio
        case SHIFT_EK:  //if alpha mode then change between upper case and lower case
               if (mode==ALPHA_MODE)
	       if (UpCase==ALPHA_DIST) UpCase=0;
               else UpCase=ALPHA_DIST;
        break;
	case DEL_EK:
	case LEFT_EK: if (index>0) {//both keys act like backspace
			 index--;
			 putchar (8);
			 putchar (' ');
			 putchar (8);
		      }; break;
	case 64://comment this for casio F6
        case EXE_EK: ndone=0; puts (""); break;//casio change
      }//switch for extended keys end
    }//if for extended key check end
    else {//non extended keys
      switch (key) {//ordinary alpha
	case 'A': case 'B': case 'C': case 'D': case 'E':
	case 'F': case 'G': case 'H': case 'I': case 'J':
	case 'K': case 'L': case 'S': case 'T': case 'X': case 'Y':
	  if (mode==ALPHA_MODE) {
            key+=UpCase;
	    putchar (key); str [index]=key; index++;
          }
        break;
        case COMA_K:
          if (mode==ALPHA_MODE) key=' ';//in alpha mode coma acts like space
          putchar (key); str [index]=key; index++;
	break;
      }//switch standart alpha
      if (mode==ALPHA_MODE)
        switch (key) {
    	  case '0':key='Z'; key+=UpCase; putchar (key); str [index]=key; index++; break;
	  case '1':key='U'; key+=UpCase; putchar (key); str [index]=key; index++; break;
  	  case '2':key='V'; key+=UpCase; putchar (key); str [index]=key; index++; break;
	  case '3':key='W'; key+=UpCase; putchar (key); str [index]=key; index++; break;
	  case '4':key='P'; key+=UpCase; putchar (key); str [index]=key; index++; break;
	  case '5':key='Q'; key+=UpCase; putchar (key); str [index]=key; index++; break;
	  case '6':key='R'; key+=UpCase; putchar (key); str [index]=key; index++; break;
	  case '7':key='M'; key+=UpCase; putchar (key); str [index]=key; index++; break;
	  case '8':key='N'; key+=UpCase; putchar (key); str [index]=key; index++; break;
	  case '9':key='O'; key+=UpCase; putchar (key); str [index]=key; index++; break;
      } else//switch numeric if alpha num
      {
        if (key>='0'&&key<='9') {
          putchar (key); str [index]=key; index++;
        }
      }
    }//non extended
  };//while
  str [index]=0;//mark end of text
}
/*
void main () {
  char string [24]="123456789";
  clrscr ();
  printf ("Podaj 24:");
  get_str (string,24,NUM_MODE);
  printf ("\n%s<--Wczytalem",string);
  anykey ();
}
*/